#!/usr/bin/perl
#
# Copyright (C) 2001, 2002, 2003, 2006, 2007, 2009 Eric de la Clergerie
#
# $Id$
#

package DyALog;
use strict;
use Test::More;

require Exporter;

our @ISA = qw(Exporter);
#our @EXPORT = qw(compile tfs_compile $SRCDIR);
our @EXPORT = qw($SRCDIR);

our $SRCDIR = "@srcdir@";

######################################################################
package Test::DyALog;
use Test::Cmd;
use base qw(Test::Cmd);
use strict;
use Test::More;

my $dyacc = '@abs_top_builddir@/Compiler/dyacc';
my $mktfs = '@abs_top_builddir@/Tfs/tfs2lib';

my @libs = qw{ -I . -I @srcdir@/ -I @abs_top_srcdir@/Runtime/ -I @abs_top_builddir@/Runtime/ -I @abs_top_srcdir@/Builtins/ -I @abs_top_srcdir@/Compiler/};

sub compile {
    my $test = shift;
    my $pgm = shift;
    my %info = @_;
    $test->prog($dyacc);
    my @input = defined $info{'input'} ? @{$info{'input'}} : ("$pgm.pl");
    my @locallibs = defined $info{'libs'} ? @{$info{'libs'}} : ();
    my $localflags = defined $info{'flags'} ? $info{'flags'} : "";
    my $output = defined $info{'output'} ? $info{'output'} : $pgm;
    $test->run( args => "@libs @locallibs $localflags -dev @input -o $output -no-fast-install",%info);
    ok($? == 0, "Compiling $pgm");
}

sub tfs_compile {
    my $test=shift;
    my $pgm = shift;
    my %info = @_;
    $test->prog($mktfs);
    my @input = defined $info{'input'} ? @{$info{'input'}} : ("$pgm.def");
    my @locallibs = defined $info{'libs'} ? @{$info{'libs'}} : ();
    my $localflags = defined $info{'flags'} ? $info{'flags'} : "";
    $test->run( args => "@libs @locallibs $localflags -dev @input",%info);
    ok($? == 0, "Compiling tfs lib $pgm");
}

sub run {
    my $self = shift;
    my %info = @_;
    $self->prog($info{prog}) if (defined $info{prog});
    if (defined $info{parse}) {
      push(@_,'stdin'=>lexer($info{parse}));
      $self->{sentence}=$info{parse};
    }
    my $return = $self->SUPER::run(@_);
    my @output = $self->stdout;
    my @lines = ();
    my @answers = ();
    my @forest = ();
    my $in_answer = 0;
    while (@output) {		# Extracting answers and comment
	my $line = shift @output;
	chop $line;
	if ($line =~ /^Answer/){
	    push(@answers,$line);
	    $in_answer = 1 unless ($line =~ /true/);
	    next;
	}
	if ($in_answer) {
	    $in_answer = 0, next unless ($line =~ /^\s*[A-Z_]+\s+=/);
	    $answers[$#answers] .= $line;
	    next;
	}
	last if ($line =~ /^Shared\s+Forest/);
	push(@lines,$line);
    }
    while (@output) {		# Extracting forest info
	my $line = shift @output;
	next if ($line =~ /^\s*$/);
	push(@forest,$line.(shift @output));
    }
    $self->{'DyALog'} = { 'answers' => [@answers],
			  'lines' => [@lines],
			  'forest' => [@forest]
			  };
    return $return;
}

sub answers {
    my $self = shift;
    return @{$self->{'DyALog'}{'answers'}};
}

sub lines {
    my $self = shift;
    return @{$self->{'DyALog'}{'lines'}};
}

sub forest {
    my $self = shift;
    return @{$self->{'DyALog'}{'forest'}};
}

sub true {
    my $self = shift;
    return grep(/^Answer:\s+true\s*$/,$self->answers);
}

sub failure (;$) {
    my $self = shift;
    return $self->answers == 0;
}

sub succeed {
    my $self = shift;
    return $self->answers != 0;
}

sub message {
    my $self = shift;
    return "Checking ".$self->basename()." @_";
}

sub fail_sentence {
  my $self = shift;
  return "Checking ".$self->basename()." fail on '$self->{sentence}'";
}

sub succeed_sentence {
  my $self = shift;
  return "Checking ".$self->basename()." succeed on '$self->{sentence}'";
}

sub in {
    my $self = shift;
    my $match = shift;
    my @lines = @_;
    return grep( $match eq $_,@lines);
}

sub lexer {
  my @sentence = split(/\s+/,$_[0]);
  my $i=0;
  my @db=();
  foreach my $word (@sentence) {
    my $j=$i+1;
    push(@db,"'C'($i,'$word',$j).");
    $i++;
  }
  push(@db,"'N'($i).","");
  return join("\n",@db);
}

1;






